package cn.estsh.i3plus.core.api.iservice.busi;


import cn.estsh.i3plus.pojo.platform.bean.SysMenu;
import cn.estsh.impp.framework.base.service.ICacheCrudService;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 系统功能业务接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 15:18:14.958
 * @Modify      :
 **/
public interface ISysMenuService extends ICacheCrudService<SysMenu> {


    @ApiOperation(value = "功能权限检查",notes = "功能权限检查(权限代码)")
    void checkSysMenuOnly(SysMenu bean);

    @ApiOperation(value = "更新内存语言缓存",notes = "更新内存语言缓存")
    void refreshMemSysMenuLanguage();

    @ApiOperation(value = "刷新权限关系",notes = "刷新角色权限关系SoftType 字段")
    void refreshRefSysMenuBySoftType();

    @ApiOperation(value = "国际化功能权限",notes = "国际化功能权限")
    List<SysMenu> setLanguageSysMenuName(String languageCode, List<SysMenu> menuList);

    @ApiOperation(value = "根据菜单代码查询菜单信息")
    SysMenu getSysMenuByCode(String code);

}
