package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysRefRoleMenu;
import cn.estsh.i3plus.pojo.platform.bean.SysRole;
import cn.estsh.i3plus.pojo.platform.bean.SysUser;
import cn.estsh.impp.framework.base.service.ICacheCrudService;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 系统角色业务接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.771
 * @Modify      :
 **/
public interface ISysRoleService extends ICacheCrudService<SysRole> {

    @ApiOperation(value = "更新角色信息",notes = "根据ID 批量更新角色状态信息")
    void updateSysRoleStatusByIds(Long[] ids, int status, SessionUser user);

    @ApiOperation(value = "刷新角色菜单关系",notes = "刷新 角色 菜单关系信息")
    void refreshSysRoleRef(Long roleId,Long[] ids,String userName);

    @ApiOperation(value = "刷新角色菜单关系",notes = "批量刷新 角色 菜单关系信息")
    void refreshBatchSysRoleRef(Long[] roleIds,Long[] ids,String userName);

    void refreshSysRoleRef(Long roleId,Integer softType,List<Long> idList,String userName);

    @ApiOperation(value = "查信角色菜单关系",notes = "查询 ID 查询角色菜单关系")
    List<SysRefRoleMenu> findSysRefRoleMenuByRoleId(Long roleId);

    @ApiOperation(value = "查信角色菜单关系",notes = "查询 ID 查询角色菜单关系")
    List<SysRefRoleMenu> findSysRefRoleMenuByRoleId(Long roleId,Integer softType);

    @ApiOperation(value = "查信角色信息",notes = "根据ID + 角色状态查询角色信息")
    List<SysRole> findSysRoleByInIdAndStatus(Long[] ids,Integer status);

    @ApiOperation(value = "查信用户的所有角色信息",notes = "查信用户的所有角色信息")
    List<SysRole> findSysRoleByUser(SysUser user);

    @ApiOperation(value = "查信角色信息",notes = "查询角色信息(分页/组合)")
    ListPager<SysRole> querySysRole(SysRole role, List<Long> idList, Pager pager);

    /***
     * 检查角色唯一性
     * @param role 角色信息
     */
    @ApiOperation(value = "角色唯一检查")
    void checkSysRoleOnly(SysRole role);

}
