package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysPojoVersionPlanService;
import cn.estsh.i3plus.platform.common.exception.ImppExceptionEnum;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.jpa.dao.BaseRepository;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.platform.bean.SysPojoVersionPlan;
import cn.estsh.i3plus.pojo.platform.repository.SysPojoVersionPlanRepository;
import cn.estsh.impp.framework.base.service.CacheCrudService;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-4-21 下午2:28
 * @Modify:
 **/
@Service
public class SysPojoVersionPlanService extends CacheCrudService<SysPojoVersionPlan> implements ISysPojoVersionPlanService {

    @Autowired
    private SysPojoVersionPlanRepository pojoVersionPlanRDao;

    @Override
    public BaseRepository<SysPojoVersionPlan, Long> getRepository() {
        return pojoVersionPlanRDao;
    }

    @Override
    public void checkSysPojoVersionPlanOnly(SysPojoVersionPlan bean) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(bean);
        DdlPreparedPack.getNumNOEqualPack(bean.getId(),"id",packBean);
        DdlPreparedPack.getNumEqualPack(bean.getSoftType(),"softType",packBean);
        DdlPreparedPack.getStringEqualPack(bean.getRefClass(),"refClass",packBean);

        if(pojoVersionPlanRDao.findByHqlWhereCount(packBean) > 0){
            throw ImppExceptionBuilder.newInstance()
                    .setSystemID(CommonEnumUtil.SOFT_TYPE.CORE.getCode())
                    .setErrorCode(ImppExceptionEnum.IO_EXCEPTION.getCode())
                    .setErrorDetail("任务计划已存在")
                    .setErrorSolution("请重新操作")
                    .build();
        }
    }

    @Override
    public SysPojoVersionPlan getSysPojoVersionPlanBySoftTypeAndClassName(Integer softType, String className) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean();
        DdlPreparedPack.getNumEqualPack(softType,"softType",packBean);
        DdlPreparedPack.getStringEqualPack(className,"refClass",packBean);
        return pojoVersionPlanRDao.getByProperty(packBean);
    }
}
